#ifndef CONFIG_H
#define	CONFIG_H

#include <xc.h>// include processor files - each processor file is guarded.

#if defined(__32MX695F512H__)
#define Rover
#elif defined(__32MX795F512H__)
#define BaseStation
#endif

// TODO Insert appropriate #include <>
#include <stdio.h>
#include <stdint.h>        /* Includes uint16_t definition */
#include <stdbool.h>       /* Includes true/false definition */

bool verbose_mode = true;

// General Helper Macros
#include "config_general_macros.h"

// Initial PIC32 Bit Configuration
#include "configuration_bits.h"

// Pin Mapping
#include "config_pins.h"

// Clock Definitions
#define FRC 8000000 /* 8MHz */
#define SCLK (FRC/2*20/1) /* 80MHz */
#define FPB (SCLK/(1<<OSCCONbits.PBDIV))

short saved_cn = 0x00;
short twos2sign(short twos) {
	return (twos & 0x8000 != 0) ? -(((~twos) & 0xFFFF) + 1) : twos;
}
short twos2sign2B(short MSB, short LSB) {
	short twos = MSB << 8 | LSB;
	return (twos & 0x8000 != 0) ? -(((~twos) & 0xFFFF) + 1) : twos;
}

// UART Configurations
#include "uart_config.h"

// Data Buffer Initializations, and Data Buffer Helper Macros/Functions
#include "buffer_config.h"

// I2C Configurations
#include "i2c_config.h"

//#include "../../pic32-libs/pic32-libs/libpic32/stubs/xc32_uart.c"
//#include "../../pic32-libs/pic32-libs/libpic32/stubs/_mon_putc.c"
//#include "../../pic32-libs/pic32-libs/libpic32/stubs/_mon_getc.c"
//#include "../../pic32-libs/pic32-libs/libpic32/stubs/_mon_puts.c"

// LoRa Configurations
#include "lora_config.h"

// GPS Configurations
#include "gps_config.h"

// Motor Configurations
#include "motor_config.h"

// Servo Configurations
#include "servo_config.h"

// Timer Configuartions
#include "timer_config.h"

// OC Configurations
#include "oc_config.h"

// Interrupt Configurations
#include "interrupt_config.h"


#endif	/* CONFIG_H */

