#ifndef CONFIGURATION_BITS_H
#define	CONFIGURATION_BITS_H

/* using internal osc
 peripheral clock = at 10MHz (80MHz/8)
*/
#pragma config FNOSC = FRCPLL // Oscillator selection (internal 8 MHz FRC with PLL)
#pragma config FPLLIDIV = DIV_2 // PLL input divider   (8MHz/2 = 4MHz) NOTE: FIN must be in range: [4,5]MHz
#pragma config FPLLMUL = MUL_20 // PLL multiplier     (4MHz*20 = 80MHz)
#pragma config FPLLODIV = DIV_1 // PLL output divider (80MHz*1 = 80MHz)
#pragma config FSOSCEN = OFF // Secondary oscillator enable
/* Clock control settings
*/
#pragma config FCKSM = CSECME // Clock switching (CSx)/Clock monitor (CMx)
/* Other Peripheral Device settings
*/
#pragma config FWDTEN = OFF // Watchdog timer enable
#pragma config	ICESEL	= ICS_PGx1	// ICE pin selection




///*  DEFAULT CONFIG BITS BELOW  */
//// PIC32MX695F512H Configuration Bit Settings
//// 'C' source line config statements
//
//// DEVCFG3
//// USERID = No Setting
////#pragma config FSRSSEL = PRIORITY_7     // SRS Select (SRS Priority 7)
////#pragma config FMIIEN = ON              // Ethernet RMII/MII Enable (MII Enabled)
////#pragma config FETHIO = ON              // Ethernet I/O Pin Select (Default Ethernet I/O)
////#pragma config FUSBIDIO = ON            // USB USID Selection (Controlled by the USB Module)
////#pragma config FVBUSONIO = ON           // USB VBUS ON Selection (Controlled by USB Module)
//
//// DEVCFG2
//#pragma config FPLLIDIV = DIV_12        // PLL Input Divider (12x Divider)
//#pragma config FPLLMUL = MUL_24         // PLL Multiplier (24x Multiplier)
////#pragma config UPLLIDIV = DIV_12        // USB PLL Input Divider (12x Divider)
////#pragma config UPLLEN = OFF             // USB PLL Enable (Disabled and Bypassed)
//#pragma config FPLLODIV = DIV_256       // System PLL Output Clock Divider (PLL Divide by 256)
//
//// DEVCFG1
//#pragma config FNOSC = FRCDIV           // Oscillator Selection Bits (Fast RC Osc w/Div-by-N (FRCDIV))
//#pragma config FSOSCEN = ON             // Secondary Oscillator Enable (Enabled)
////#pragma config IESO = ON                // Internal/External Switch Over (Enabled)
//#pragma config POSCMOD = OFF            // Primary Oscillator Configuration (Primary osc disabled)
//#pragma config OSCIOFNC = OFF           // CLKO Output Signal Active on the OSCO Pin (Disabled)
////#pragma config FPBDIV = DIV_8           // Peripheral Clock Divisor (Pb_Clk is Sys_Clk/8)
//#pragma config FCKSM = CSDCMD           // Clock Switching and Monitor Selection (Clock Switch Disable, FSCM Disabled)
//#pragma config WDTPS = PS1048576        // Watchdog Timer Postscaler (1:1048576)
//#pragma config FWDTEN = ON              // Watchdog Timer Enable (WDT Enabled)
//
//// DEVCFG0
////#pragma config DEBUG = OFF              // Background Debugger Enable (Debugger is disabled)
//#pragma config ICESEL = ICS_PGx2        // ICE/ICD Comm Channel Select (ICE EMUC2/EMUD2 pins shared with PGC2/PGD2)
////#pragma config PWP = OFF                // Program Flash Write Protect (Disable)
////#pragma config BWP = OFF                // Boot Flash Write Protect bit (Protection Disabled)
////#pragma config CP = OFF                 // Code Protect (Protection Disabled)

#endif	/* CONFIGURATION_BITS_H */