/* 
 * File:   i2c_config.h
 * Author: cstgeo
 *
 * Created on February 10, 2018, 3:48 PM
 */

#ifndef I2C_CONFIG_H
#define	I2C_CONFIG_H
#include "config.h"

const struct {
	unsigned char ACT_THS; /* r/w (0x04 / 0b00000100) default: 00000000 */
	unsigned char ACT_DUR; /* r/w (0x05 / 0b00000101) default: 00000000 */
	unsigned char INT_GEN_CFG_XL; /* r/w (0x06 / 0b00000110) default: 00000000 */
	unsigned char INT_GEN_THS_X_XL; /* r/w (0x07 / 0b00000111) default: 00000000 */
	unsigned char INT_GEN_THS_Y_XL; /* r/w (0x08 / 0b00001000) default: 00000000 */
	unsigned char INT_GEN_THS_Z_XL; /* r/w (0x09 / 0b00001001) default: 00000000 */
	unsigned char INT_GEN_DUR_XL; /* r/w (0x0A / 0b00001010) default: 00000000 */
	unsigned char REFERENCE_G; /* r/w (0x0B / 0b00001011) default: 00000000 */
	unsigned char INT1_CTRL; /* r/w (0x0C / 0b00001100) default: 00000000 */
	unsigned char INT2_CTRL; /* r/w (0x0D / 0b00001101) default: 00000000 */
	unsigned char WHO_AM_I; /* r (0x0F / 0b00001111) default: 01101000 */
	unsigned char CTRL_REG1_G; /* r/w (0x10 / 0b00010000) default: 00000000 */
	unsigned char CTRL_REG2_G; /* r/w (0x11 / 0b00010001) default: 00000000 */
	unsigned char CTRL_REG3_G; /* r/w (0x12 / 0b00010010) default: 00000000 */
	unsigned char ORIENT_CFG_G; /* r/w (0x13 / 0b00010011) default: 00000000 */
	unsigned char INT_GEN_SRC_G; /* r (0x14 / 0b00010100) default: output */
	unsigned char OUT_TEMP_L; /* r (0x15 / 0b00010101) default: output */
	unsigned char OUT_TEMP_H; /* r (0x16 / 0b00010110) default: output */
	unsigned char STATUS_REG; /* r (0x17 / 0b00010111) default: output */
	unsigned char OUT_X_L_G; /* r (0x18 / 0b00011000) default: output */
	unsigned char OUT_X_H_G; /* r (0x19 / 0b00011001) default: output */
	unsigned char OUT_Y_L_G; /* r (0x1A / 0b00011010) default: output */
	unsigned char OUT_Y_H_G; /* r (0x1B / 0b00011011) default: output */
	unsigned char OUT_Z_L_G; /* r (0x1C / 0b00011100) default: output */
	unsigned char OUT_Z_H_G; /* r (0x1D / 0b00011101) default: output */
	unsigned char CTRL_REG4; /* r/w (0x1E / 0b00011110) default: 00111000 */
	unsigned char CTRL_REG5_XL; /* r/w (0x1F / 0b00011111) default: 00111000 */
	unsigned char CTRL_REG6_XL; /* r/w (0x20 / 0b00100000) default: 00000000 */
	unsigned char CTRL_REG7_XL; /* r/w (0x21 / 0b00100001) default: 00000000 */
	unsigned char CTRL_REG8; /* r/w (0x22 / 0b00100010) default: 00000100 */
	unsigned char CTRL_REG9; /* r/w (0x23 / 0b00100011) default: 00000000 */
	unsigned char CTRL_REG10; /* r/w (0x24 / 0b00100100) default: 00000000 */
	unsigned char INT_GEN_SRC_XL; /* r (0x26 / 0b00100110) default: output */
	unsigned char STATUS_REG2; /* r (0x27 / 0b00100111) default: output */
	unsigned char OUT_X_L_XL; /* r (0x28 / 0b00101000) default: output */
	unsigned char OUT_X_H_XL; /* r (0x29 / 0b00101001) default: output */
	unsigned char OUT_Y_L_XL; /* r (0x2A / 0b00101010) default: output */
	unsigned char OUT_Y_H_XL; /* r (0x2B / 0b00101011) default: output */
	unsigned char OUT_Z_L_XL; /* r (0x2C / 0b00101100) default: output */
	unsigned char OUT_Z_H_XL; /* r (0x2D / 0b00101101) default: output */
	unsigned char FIFO_CTRL; /* r/w (0x2E / 0b00101110) default: 00000000 */
	unsigned char FIFO_SRC; /* r (0x2F / 0b00101111) default: output */
	unsigned char INT_GEN_CFG_G; /* r/w (0x30 / 0b00110000) default: 00000000 */
	unsigned char INT_GEN_THS_XH_G; /* r/w (0x31 / 0b00110001) default: 00000000 */
	unsigned char INT_GEN_THS_XL_G; /* r/w (0x32 / 0b00110010) default: 00000000 */
	unsigned char INT_GEN_THS_YH_G; /* r/w (0x33 / 0b00110011) default: 00000000 */
	unsigned char INT_GEN_THS_YL_G; /* r/w (0x34 / 0b00110100) default: 00000000 */
	unsigned char INT_GEN_THS_ZH_G; /* r/w (0x35 / 0b00110101) default: 00000000 */
	unsigned char INT_GEN_THS_ZL_G; /* r/w (0x36 / 0b00110110) default: 00000000 */
	unsigned char INT_GEN_DUR_G; /* r/w (0x37 / 0b00110111) default: 00000000 */
} GA_SUB = {
								0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D,       0x0F,
								0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F,
								0x20, 0x21, 0x22, 0x23, 0x24,			  0x26, 0x27, 0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F,
								0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37
};

const struct {
	unsigned char AG;
	unsigned char M;
} GAM_SAD = {0x6B,0x1E};
const char LDR_SAD = 0xC5;

#define W 0
#define R 1
#define Read_Address(SAD) (SAD << 1 | R) /* 8-bit read address */
#define Write_Address(SAD) (SAD << 1 | W) /* 8-bit write address */

#define ALT_WRITE 0xC0
#define ALT_READ 0xC1
#define lidar_read 0xC5
#define lidar_write 0xC4
#define GAM_WRITE Write_Address(GAM_SAD.AG)/*0xD6*/
#define GAM_READ  Read_Address(GAM_SAD.AG)/*0xD7*/

#define MST_INT IFS0bits.I2C1MIF
void configure_iic();
int startI2C();
int putI2C(int data);
void stopI2C(void);
void rstartI2C(void);
unsigned char getI2C(int ack2send);

#include "gam_config.h"
#include "alt_config.h"
#include "lidar_config.h"

void configure_iic() { // configure I2C communication
    printConfigurationStarted(IIC);
    I2C1BRG = 0x02F;
    I2C1CONbits.ON = 1;
		configure_alt();
    configure_gam();
//		configure_lidar();
		printConfigurationCompleted(IIC);
}
int startI2C() {
    MST_INT = 0;
    I2C1CONbits.SEN = 1;
    while (!MST_INT); //wait for communication from I2
}
int putI2C(int data) {//send data to I2C
    MST_INT = 0;
    I2C1TRN = data;
    while(!MST_INT);
    return(I2C1STATbits.ACKSTAT);
}
void stopI2C(void) { //turn off I2C
    MST_INT = 0;
    I2C1CONbits.PEN = 1;
    while(!MST_INT); //wait for response
}
void rstartI2C(void) {
    MST_INT = 0;
    I2C1CONbits.RSEN = 1;
    while(!MST_INT);
}
unsigned char getI2C(int ack2send) { //get response from I2C
    MST_INT = 0;
    unsigned char inByte;
    I2C1CONbits.RCEN = 1;
    while(!MST_INT);
    MST_INT = 0;
    inByte = I2C1RCV;
    I2C1CONbits.ACKEN = 1;
    I2C1CONbits.ACKDT = ack2send;
    while(!MST_INT);
    return(inByte);
}

#endif	/* I2C_CONFIG_H */

