/* 
 * File:   interrupt_config_UART_BLE.h
 * Author: cstgeo
 *
 * Created on February 11, 2018, 2:35 PM
 */

#ifndef INTERRUPT_CONFIG_UART_BLE_H
#define	INTERRUPT_CONFIG_UART_BLE_H
#include "config.h"

// BLE UART (UART 6)
#define BLE_UART_Transmit_Interrupt_Flag UART_6_Transmit_Interrupt_Flag
#define BLE_UART_Transmit_Interrupt_Mode_Select UART_6_Transmit_Interrupt_Mode_Select
#define BLE_UART_Receive_Interrupt_Flag UART_6_Receive_Interrupt_Flag
#define BLE_UART_Receive_Interrupt_Mode_Select UART_6_Receive_Interrupt_Mode_Select
#define BLE_UART_Error_Interrupt_Flag UART_6_Error_Interrupt_Flag
#define BLE_UART_Parity_Error_Status UART_6_Parity_Error_Status
#define BLE_UART_Framing_Error_Status UART_6_Framing_Error_Status
#define BLE_UART_Receive_Buffer_Overflow_Status UART_6_Receive_Buffer_Overflow_Status
#define BLE_UART_Interrupt_Priority UART_6_Interrupt_Priority
#define BLE_UART_Interrupt_Subpriority UART_6_Interrupt_Subpriority
#define BLE_UART_Transmit_Interrupt_Enable UART_6_Transmit_Interrupt_Enable
#define BLE_UART_Receive_Interrupt_Enable UART_6_Receive_Interrupt_Enable
#define BLE_UART_Error_Interrupt_Enable UART_6_Error_Interrupt_Enable

UART_Interrupt(BLE,6,6,1,Interrupt,
        /*tx interrupts*/disabled,
        /*rx interrupts*/enabled,
        /*err interrupts*/disabled,
        UART_Transmit_Interrupt_Mode.Buffer_Just_Emptied,
        UART_Receive_Interrupt_Mode.Buffer_Not_Empty) {
// printf("\n\rvoid BLE_UART_Interrupt_Event()");
 if(BLE_UART_Transmit_Interrupt_Enable && BLE_UART_Transmit_Interrupt_Flag) // Transmitter-buffer-empty interrupt
 {
  printf("\n\r\tUART6-Transmitter-buffer-empty interrupt");
  BLE_UART_Transmit_Interrupt_Flag = false; // clear flag
 } 
 if(BLE_UART_Receive_Interrupt_Enable && BLE_UART_Receive_Interrupt_Flag) // Receiver-data-available interrupt
 {
//  printf("\n\r\tUART6-Receiver-data-available interrupt");
  __XC_UART = __BLE_UART;
	char c = _mon_getc(0);
	__XC_UART = __PC_UART;
	_mon_putc(c);
  BLE_UART_Receive_Interrupt_Flag = false; // clear flag
 }
 if(BLE_UART_Error_Interrupt_Enable && BLE_UART_Error_Interrupt_Flag) // UART-error interrupt
 {
  printf("\n\r\tUART6-error interrupt");
  if (BLE_UART_Parity_Error_Status) // Parity Error
  {
   printf("\n\r\t\tParity Error");
  }
  if (BLE_UART_Framing_Error_Status) // Framing Error
  {
   printf("\n\r\t\tFraming Error");
  }
  if (BLE_UART_Receive_Buffer_Overflow_Status) // RX Buffer Overflow
  {
   printf("\n\r\t\tRX Buffer Overflow");
  }
  BLE_UART_Error_Interrupt_Flag = false; // clear flag
 }
}

#endif	/* INTERRUPT_CONFIG_UART_BLE_H */

