/* 
 * File:   interrupt_config_UART_GPS.h
 * Author: cstgeo
 *
 * Created on April 7, 2018, 2:05 AM
 */

#ifndef INTERRUPT_CONFIG_UART_GPS_H
#define	INTERRUPT_CONFIG_UART_GPS_H
#include "config.h"

// GPS UART (UART 5)
#define GPS_UART_Transmit_Interrupt_Flag UART_5_Transmit_Interrupt_Flag
#define GPS_UART_Transmit_Interrupt_Mode_Select UART_5_Transmit_Interrupt_Mode_Select
#define GPS_UART_Receive_Interrupt_Flag UART_5_Receive_Interrupt_Flag
#define GPS_UART_Receive_Interrupt_Mode_Select UART_5_Receive_Interrupt_Mode_Select
#define GPS_UART_Error_Interrupt_Flag UART_5_Error_Interrupt_Flag
#define GPS_UART_Parity_Error_Status UART_5_Parity_Error_Status
#define GPS_UART_Framing_Error_Status UART_5_Framing_Error_Status
#define GPS_UART_Receive_Buffer_Overflow_Status UART_5_Receive_Buffer_Overflow_Status
#define GPS_UART_Interrupt_Priority UART_5_Interrupt_Priority
#define GPS_UART_Interrupt_Subpriority UART_5_Interrupt_Subpriority
#define GPS_UART_Transmit_Interrupt_Enable UART_5_Transmit_Interrupt_Enable
#define GPS_UART_Receive_Interrupt_Enable UART_5_Receive_Interrupt_Enable
#define GPS_UART_Error_Interrupt_Enable UART_5_Error_Interrupt_Enable

struct {
	sym UTC_Time[11];					// hhmmss.sss
	sym Status;							// A == data valid, V == data not valid
	sym Latitude[10];					// ddmm.mmmm
	sym NS_Indicator;					// N == north, S == south
	sym Longitude[11];						// 
	sym EW_Indicator;
	sym Speed_over_Ground[5];
	sym Course_over_Ground[10];
	sym Date[7];
	sym Magnetic_Variation_Deg[5];
	sym Magnetic_Variation_Indicator;
} RMC_data = {};
sym RMC_string[80] = {0};
sym * RMC_string_data;


UART_Interrupt(GPS,5,6,1,Interrupt,
        /*tx interrupts*/disabled,
        /*rx interrupts*/enabled,
        /*err interrupts*/disabled,
        UART_Transmit_Interrupt_Mode.Buffer_Just_Emptied,
        UART_Receive_Interrupt_Mode.Buffer_Not_Empty) {
// printf("\n\rvoid GPS_UART_Interrupt_Event()");
 if(GPS_UART_Transmit_Interrupt_Enable && GPS_UART_Transmit_Interrupt_Flag) // Transmitter-buffer-empty interrupt
 {
  printf("\n\r\tUART5-Transmitter-buffer-empty interrupt");
  GPS_UART_Transmit_Interrupt_Flag = false; // clear flag
 } else 
 if(GPS_UART_Receive_Interrupt_Enable && GPS_UART_Receive_Interrupt_Flag) // Receiver-data-available interrupt
 {
	char c = GPSRXREG;
	switch (c) {
        case '\n': { gps_uart_state = GPS_UART_STRING_RECEIVED; break; }
        case '$':  {
            gps_uart_state = GPS_UART_RECEIVING_STRING_TYPE;
            gps_incoming_string_index = 0;
            gps_comma_count = 0;
            break;
				}
        case ',':  { 
					gps_incoming_string_current_data_section_index = 0;
					gps_comma_count += 1;
					break;
				}
  }
    /* GPGGA, GPGSA, GPGSV, GPRMC, GPVTG */
			switch (gps_uart_state) 
			{
        case GPS_UART_RECEIVING_STRING_TYPE: {
            set_type_if_gps_data_type(gga) else
            set_type_if_gps_data_type(gsa) else
            set_type_if_gps_data_type(gsv) else
            set_type_if_gps_data_type(rmc) else
            set_type_if_gps_data_type(vtg)
            break;
        }
        case GPS_UART_RECEIVING_STRING_TYPE_VERIFIED: {
            if (gps_comma_count == 1) { gps_uart_state = GPS_RECEIVING_STRING_DATA; RMC_string_data = RMC_string + gps_incoming_string_index+1; }
            break;
        }
        case GPS_RECEIVING_STRING_DATA: 
				{
						if (gps_data_type == GPS_DATA_TYPE_RMC) 
						{
							RMC_string[gps_incoming_string_index] = c; RMC_string[gps_incoming_string_index+1] = ' '; RMC_string[gps_incoming_string_index+2] = 0;
							if (gps_comma_count ==  1) { RMC_data.UTC_Time[gps_incoming_string_current_data_section_index++] = c;
																					 RMC_data.UTC_Time[gps_incoming_string_current_data_section_index  ] = 0; } else
							if (gps_comma_count ==  2) { RMC_data.Status = c; } else
							if (gps_comma_count ==  3) { RMC_data.Latitude[gps_incoming_string_current_data_section_index++] = c;
																					 RMC_data.Latitude[gps_incoming_string_current_data_section_index  ] = 0; } else
							if (gps_comma_count ==  4) { RMC_data.NS_Indicator = c; } else
							if (gps_comma_count ==  5) { RMC_data.Longitude[gps_incoming_string_current_data_section_index++] = c;
																					 RMC_data.Longitude[gps_incoming_string_current_data_section_index  ] = 0; } else
							if (gps_comma_count ==  6) { RMC_data.EW_Indicator = c; } else
							if (gps_comma_count ==  7) { RMC_data.Speed_over_Ground[gps_incoming_string_current_data_section_index++] = c;
																					 RMC_data.Speed_over_Ground[gps_incoming_string_current_data_section_index  ] = 0; } else
							if (gps_comma_count ==  8) { RMC_data.Course_over_Ground[gps_incoming_string_current_data_section_index++] = c;
																					 RMC_data.Course_over_Ground[gps_incoming_string_current_data_section_index  ] = 0; } else
							if (gps_comma_count ==  9) { RMC_data.Date[gps_incoming_string_current_data_section_index++] = c;
																					 RMC_data.Date[gps_incoming_string_current_data_section_index  ] = 0; } else
							if (gps_comma_count == 10) { RMC_data.Magnetic_Variation_Deg[gps_incoming_string_current_data_section_index++] = c;
																					 RMC_data.Magnetic_Variation_Deg[gps_incoming_string_current_data_section_index  ] = 0; } else
							if (gps_comma_count == 10) { RMC_data.Magnetic_Variation_Indicator = c; }
						}
//							GPS_DATA_TYPE_GGA
//							GPS_DATA_TYPE_GSA
//							GPS_DATA_TYPE_GSV
//							GPS_DATA_TYPE_VTG
					break;
				}
            case GPS_UART_STRING_RECEIVED: { break; }
      }
				gps_incoming_string_index+=1;
				GPS_UART_Receive_Interrupt_Flag = false; // clear flag
  } else
 if(GPS_UART_Error_Interrupt_Enable && GPS_UART_Error_Interrupt_Flag) // UART-error interrupt
 {
  printf("\n\r\tUART5-error interrupt");
  if (GPS_UART_Parity_Error_Status) // Parity Error
  {
   printf("\n\r\t\tParity Error");
  }
  if (GPS_UART_Framing_Error_Status) // Framing Error
  {
   printf("\n\r\t\tFraming Error");
  }
  if (GPS_UART_Receive_Buffer_Overflow_Status) // RX Buffer Overflow
  {
   printf("\n\r\t\tRX Buffer Overflow");
  }
  GPS_UART_Error_Interrupt_Flag = false; // clear flag
 }
}


#endif	/* INTERRUPT_CONFIG_UART_GPS_H */

