/* 
 * File:   interrupt_config_UART_PC.h
 * Author: cstgeo
 *
 * Created on February 11, 2018, 2:24 PM
 */

#ifndef INTERRUPT_CONFIG_UART_PC_H
#define	INTERRUPT_CONFIG_UART_PC_H
#include "config.h"

// PC UART (UART 3)
#define __PC_UART 3
#define PC_UART_Transmit_Interrupt_Flag UART_3_Transmit_Interrupt_Flag
#define PC_UART_Transmit_Interrupt_Mode_Select UART_3_Transmit_Interrupt_Mode_Select
#define PC_UART_Receive_Interrupt_Flag UART_3_Receive_Interrupt_Flag
#define PC_UART_Receive_Interrupt_Mode_Select UART_3_Receive_Interrupt_Mode_Select
#define PC_UART_Error_Interrupt_Flag UART_3_Error_Interrupt_Flag
#define PC_UART_Parity_Error_Status UART_3_Parity_Error_Status
#define PC_UART_Framing_Error_Status UART_3_Framing_Error_Status
#define PC_UART_Receive_Buffer_Overflow_Status UART_3_Receive_Buffer_Overflow_Status
#define PC_UART_Interrupt_Priority UART_3_Interrupt_Priority
#define PC_UART_Interrupt_Subpriority UART_3_Interrupt_Subpriority
#define PC_UART_Transmit_Interrupt_Enable UART_3_Transmit_Interrupt_Enable
#define PC_UART_Receive_Interrupt_Enable UART_3_Receive_Interrupt_Enable
#define PC_UART_Error_Interrupt_Enable UART_3_Error_Interrupt_Enable

UART_Interrupt(PC,3,4,1,Interrupt,
        /*tx interrupts*/disabled,
        /*rx interrupts*/enabled,
        /*err interrupts*/disabled,
        UART_Transmit_Interrupt_Mode.Buffer_Just_Emptied,
        UART_Receive_Interrupt_Mode.Buffer_Not_Empty) {
 if(PC_UART_Transmit_Interrupt_Enable && PC_UART_Transmit_Interrupt_Flag) // Transmitter-buffer-empty interrupt
 {printf("\n\r\tUART Transmit Interrupt");
  PC_UART_Transmit_Interrupt_Flag = false; // clear flag
 }
 if(PC_UART_Receive_Interrupt_Enable && PC_UART_Receive_Interrupt_Flag) // Receiver-data-available interrupt
 {
  __XC_UART = __PC_UART;
	char c = _mon_getc(0);
	_mon_putc(c);
//	printf("%X",c);
  PC_UART_Receive_Interrupt_Flag = false; // clear flag
 }
 if(PC_UART_Error_Interrupt_Enable && PC_UART_Error_Interrupt_Flag) // UART-error interrupt
 {printf("\n\r\tUART-error interrupt");
  if (PC_UART_Parity_Error_Status) // Parity Error
  {printf("\n\r\t\tParity Error");}
  if (PC_UART_Framing_Error_Status) // Framing Error
  {printf("\n\r\t\tFraming Error");}
  if (PC_UART_Receive_Buffer_Overflow_Status) // RX Buffer Overflow
  {printf("\n\r\t\tRX Buffer Overflow");}
  PC_UART_Error_Interrupt_Flag = false; // clear flag
 }
}

#endif	/* INTERRUPT_CONFIG_UART_PC_H */

