/* 
 * File:   lidar_config.h
 * Author: cstgeo
 *
 * Created on April 27, 2018, 1:08 PM
 */

#ifndef LIDAR_CONFIG_H
#  define	LIDAR_CONFIG_H
#include "config.h"

// I2C LIDAR Definitions

/* Possible values for LIDAR_SAD: {0x62} */
#define LIDAR_SAD	     0x62

sym lidar_data[LIDAR_REG_COUNT+1] = {0};

void configure_lidar();
#define numCounts 500
sym * read_lidar(){
    int disCount = 0;
    unsigned char byte;
    unsigned char check = 0xFF;
    configure_lidar();
    while (check != 0x00){
        startI2C();
        putI2C(lidar_write);
        putI2C(0x01);
        stopI2C();
        startI2C();
        putI2C(lidar_read);
        byte = getI2C(1);
        check = byte & 0b00000001;
        stopI2C();
    }
    startI2C();
    putI2C(lidar_write);
    putI2C(0x8f);
    stopI2C();
    startI2C();
    putI2C(lidar_read);
		lidar_data[0] = getI2C(0);
		lidar_data[1] = getI2C(1);
		stopI2C();
		
    print_ldr_data(lidar_data);
    return lidar_data;
}

void configure_lidar() {//initialize LIDAR and get first reading
    startI2C();
    putI2C(lidar_write & 0xFE);
    putI2C(0x00); //write device command
    putI2C(0x04); //take distance measurement without receiver bias correction
    stopI2C();
}

typedef struct {
	int distance_cm; // Distance to nearest obstruction in cm
	float distance_ft; // Distance to nearest obstruction in feet
} ldr_data_struct;

ldr_data_struct convert_ldr_data(sym * data) {
	ldr_data_struct ldr = {};
	ldr.distance_cm = (int)data[0] << 8 | (int)data[1];
	ldr.distance_ft = (float)ldr.distance_cm/2.54/12.0;
	return ldr;
}

void print_ldr_data(sym * data) {
		ldr_data_struct ldr = convert_ldr_data(data);
		set_UART_PC;
		if (verbose_mode) { printf("\t\t\t\t\t\t\t\t"); } printf("\t" "obs = %d cm (%2.2f ft) ahead\n\r", ldr.distance_cm, ldr.distance_ft);
}

#endif	/* LIDAR_CONFIG_H */

