///* 
// * File:   main.c
// */

#include "config.h"

void setup_devices()
{
 DDPCONbits.JTAGEN = 0; // turn off JTAG Controller Pins
 AD1PCFG = 0xFFFF; // set ANx Pins to Digital mode

 /* Setup Pins */
		  configure_pins();
		  
//		  configure_lora();
 /* Setup UART */ 
		  configure_uart();
 /* Setup Data Buffers */
		  configure_buffers();
 /* Setup Interrupts */
		  configure_interrupts();
 /* Setup Timers */
		  configure_timers();

#if defined(Rover)	

		  configure_iic();
		  configure_oc();
//		  configure_servo();
		  B_IO.BLE_nRESET = input; // set to input when ad_init not used
		  
//		  ADPCFG.SRV_ANG0 = 0;
//		  ADPCFG.SRV_ANG1 = 0;
		  /** MUX */
		  // Enable MUX
		  
		  E.MUX_nEN = 0;
		  E.MUX_S = 1;
		  B.GPS_nRESET = 1;
		  B.BLE_nRESET = 0;
		  
		  stopRover();
		  		  
#elif defined(BaseStation)
		  
#endif
		  configure_data_printing();
		  printf("\n\r" "<>-------------------------------------<>" "\n\n\r");
}

int command_count;
void print_com_data(sym * data) {
 command com = convert_com_data(data);
 set_UART_PC;
 printf("Command %d: ",command_count);
 print_command(com);
 printf("\n\r");
 command_count += 1;
}

int data_reception_count = 0;
void do_this_after_getting_lora_data() {
 printf("\tLoRa Reception: %d\n\r", ++data_reception_count);
 int index = 0;
 command_count = 0;
 incoming_queue.set_empty();
 incoming_queue.enqueue_lora_nybbles(received_lora_data);
 received_lora_data[0] = 0;
 printf("\tcp: %X\n\r",incoming_queue.chunk_pointer[0][0]);
 for (index = incoming_queue.first_chunk_pointer_index; index <= incoming_queue.last_chunk_pointer_index; index++) {
  sym t = incoming_queue.chunk_pointer[index][-1]; 
  sym c = incoming_queue.chunk_pointer[index][0];
  if(t == 1){
   command_queue.add_symbol(for_COM,c,true);
   printf("Command %d: ",command_count);
   print_command((command)c);
   printf("\n\r");
   command_count += 1;
  }
 }
 
 while (!incoming_queue.is_empty()) {
  sym * s = incoming_queue.dequeue();
  switch (s[-1]) {
//   case for_COM  : {print.com(s); break;}
//   case from_LORA: {print.lora(s); break;}
//   case from_PC  : {print.pc(s); break;}
   case from_LDR : {print.ldr(s); break;}
   case from_GPS : {print.gps(s); break;}
   case from_BLE : {print.ble(s); break;}
   case from_ALT : {print.alt(s); break;}
   case from_GAM : {print.gam(s); break;}
   case from_PIC : {print.pic(s); break;}
  }
 }
}
 
void do_this_before_every_lora_rx() {
// printf("void do_this_before_every_lora_rx() {" "\r\n");
 // clear incoming_queue before it is filled with new information via the lora module
 incoming_queue.set_empty();
 
#if defined(Rover)
#elif defined(BaseStation)
#endif
// printf("}" "\r\n");
}


int transmission_count = 0;
void print_pic_data(sym * data) {
 set_UART_PC;
 printf("PIC32: %s" "\r\n", data);
}
void do_this_during_every_lora_rx() {
// printf("void do_this_during_every_lora_rx() {" "\r\n");
#if defined(Rover)
    set_UART_PC;
//    if (current_data_out_mode == Send_GPS_Data || current_data_out_mode == Send_All_Data) { data_queue.enqueue(from_GPS, RMC_string); }
    if (current_data_out_mode == Send_ALT_Data || current_data_out_mode == Send_All_Data) { data_queue.enqueue(from_ALT, read_alt()); }
    if (current_data_out_mode == Send_GAM_Data || current_data_out_mode == Send_All_Data) { data_queue.enqueue(from_GAM, read_gam()); }
    if (current_data_out_mode == Send_LDR_Data || current_data_out_mode == Send_All_Data) { data_queue.enqueue(from_LDR, read_lidar()); }
#elif defined(BaseStation)
#endif
// printf("}" "\r\n");
}

void do_this_after_every_lora_rx() {
// printf("void do_this_after_every_lora_rx() {" "\r\n");
#if defined(Rover)
 outgoing_queue.enqueue_lora_nybbles(data_queue.nybble);
 data_queue.set_empty();
#elif defined(BaseStation)  
#endif
 
// set_UART_PC;
// printf("\r");
// int i;
// for(i=0; i<5; i++) {
//  printf("%c%c%c",0x1B,0x5B,0x42);
// }

// printf("}" "\r\n");
}

void do_this_before_every_lora_tx() {
// printf("void do_this_before_every_lora_tx() {" "\r\n");
 
#if defined(Rover)
 
#elif defined(BaseStation)
#endif
// printf("}" "\r\n");
}

void do_this_during_every_lora_tx() {
// printf("void do_this_during_every_lora_tx() {" "\r\n");
#if defined(Rover)
#elif defined(BaseStation)
#endif
// printf("}" "\r\n");
}

void do_this_after_every_lora_tx() {
// printf("void do_this_after_every_lora_tx() {" "\r\n");
 // clear outgoing_queue after it has been successfully transmitted via the lora module
 outgoing_queue.set_empty();
#if defined(Rover)
#elif defined(BaseStation)  
 updateCN();
#endif
// printf("}" "\r\n");
}

int distance = 10000;
float altitude = 0;

int main(int argc, char** argv)
{
 setup_devices();
 while (true)
 {
  LoRa();
#if defined(Rover)
  Command();
//  BLE();
//  GPS();
//  Servo();
#endif
 }
 return (EXIT_SUCCESS);
}


