/* 
 * File:   motor_config.h
 * Author: cstgeo
 *
 * Created on April 14, 2018, 5:26 PM
 */

#ifndef MOTOR_CONFIG_H
#  define	MOTOR_CONFIG_H
#include "config.h"

#define ED_Mode 0 /* input 1 controls motor direction, input 2 enables the motor (it is an active-low brake input) */
#define II_Mode 1 /* input 1 controls motor direction, input 2 enables the motor (it is an active-low brake input) */


#define DIRECTION_SET(driver, motor, direction) D.driver##_##motor##DIR = direction
#define SPEED_SET(driver, motor, speed) D.driver##_##motor##SPD = speed%2
#define BRAKE_SET(driver, motor, does_break) E.driver##_##motor##BRKEN = does_break

#define MOTOR_SET(driver, motor, direction, speed, does_break)\
	DIRECTION_SET(driver, motor, direction);\
	SPEED_SET(driver, motor, speed);\
	BRAKE_SET(driver, motor, does_break)

#define RightSideUp 0;
#define UpSideDown 1;
bool orientation = UpSideDown;

#if defined(Rover)
void driveBackward(){
		D.MD_DIR = orientation?0b1010:0b0101;
		D.MD_SPD = 0b1111;
		E.MD_BRKEN = 0b0000;
}
void driveForward(){
    D.MD_DIR = orientation?0b0101:0b1010;
		D.MD_SPD = 0b1111;
		E.MD_BRKEN = 0b0000;
}

void turnLeft() {
    D.MD_DIR = orientation?0b1111:0b0000;
		D.MD_SPD = 0b1111;
		E.MD_BRKEN = 0b0000;
}
void turnRight() {
    D.MD_DIR = orientation?0b0000:0b1111;
		D.MD_SPD = 0b1111;
		E.MD_BRKEN = 0b0000;
}
void stopRover() {
    D.MD_DIR = 0;
		D.MD_SPD = 0;
		E.MD_BRKEN = 0;
}
#endif


#endif	/* MOTOR_CONFIG_H */

