/* 
 * File:   timer_config.h
 * Author: Chris St. George
 */

#ifndef TIMER_CONFIG_H
#define	TIMER_CONFIG_H

#include "config.h"

// Timer 1
#define Timer_1_On T1CONbits.TON
#define Timer_1_Gated T1CONbits.TGATE
#define Timer_1_Source_Select T1CONbits.TCS
#define Timer_1_Prescale_Select T1CONbits.TCKPS
#define Timer_1_Prescale_1		Timer_1_Prescale_Select = 0b00
#define Timer_1_Prescale_8		Timer_1_Prescale_Select = 0b01
#define Timer_1_Prescale_64		Timer_1_Prescale_Select = 0b10
#define Timer_1_Prescale_256	Timer_1_Prescale_Select = 0b11
#define Timer_1_Count TMR1
#define Timer_1_Period PR1

// Timer 2 
#define Timer_2_On T2CONbits.TON
#define Timer_2_Gated T2CONbits.TGATE
#define Timer_2_Prescale_Select T2CONbits.TCKPS
#define Timer_2_Prescale_1		Timer_2_Prescale_Select = 0b000
#define Timer_2_Prescale_2		Timer_2_Prescale_Select = 0b001
#define Timer_2_Prescale_4		Timer_2_Prescale_Select = 0b010
#define Timer_2_Prescale_8		Timer_2_Prescale_Select = 0b011
#define Timer_2_Prescale_16		Timer_2_Prescale_Select = 0b100
#define Timer_2_Prescale_32		Timer_2_Prescale_Select = 0b101
#define Timer_2_Prescale_64		Timer_2_Prescale_Select = 0b110
#define Timer_2_Prescale_256	Timer_2_Prescale_Select = 0b111
#define Timer_2_Count TMR2
#define Timer_2_Period PR2

// Timer 3
#define Timer_3_On T3CONbits.TON
#define Timer_3_Gated T3CONbits.TGATE
#define Timer_3_Prescale_Select T3CONbits.TCKPS
#define Timer_3_Prescale_1		Timer_3_Prescale_Select = 0b000
#define Timer_3_Prescale_2		Timer_3_Prescale_Select = 0b001
#define Timer_3_Prescale_4		Timer_3_Prescale_Select = 0b010
#define Timer_3_Prescale_8		Timer_3_Prescale_Select = 0b011
#define Timer_3_Prescale_16		Timer_3_Prescale_Select = 0b100
#define Timer_3_Prescale_32		Timer_3_Prescale_Select = 0b101
#define Timer_3_Prescale_64		Timer_3_Prescale_Select = 0b110
#define Timer_3_Prescale_256	Timer_3_Prescale_Select = 0b111
#define Timer_3_Count TMR3
#define Timer_3_Period PR3

// Timer 4
#define Timer_4_On T4CONbits.TON
#define Timer_4_Gated T4CONbits.TGATE
#define Timer_4_Prescale_Select T4CONbits.TCKPS
#define Timer_4_Prescale_1		Timer_4_Prescale_Select = 0b000
#define Timer_4_Prescale_2		Timer_4_Prescale_Select = 0b001
#define Timer_4_Prescale_4		Timer_4_Prescale_Select = 0b010
#define Timer_4_Prescale_8		Timer_4_Prescale_Select = 0b011
#define Timer_4_Prescale_16		Timer_4_Prescale_Select = 0b100
#define Timer_4_Prescale_32		Timer_4_Prescale_Select = 0b101
#define Timer_4_Prescale_64		Timer_4_Prescale_Select = 0b110
#define Timer_4_Prescale_256	Timer_4_Prescale_Select = 0b111
#define Timer_4_Count TMR4
#define Timer_4_Period PR4

// Timer 5
#define Timer_5_On T5CONbits.TON
#define Timer_5_Gated T5CONbits.TGATE
#define Timer_5_Prescale_Select T5CONbits.TCKPS
#define Timer_5_Prescale_1		Timer_5_Prescale_Select = 0b000
#define Timer_5_Prescale_2		Timer_5_Prescale_Select = 0b001
#define Timer_5_Prescale_4		Timer_5_Prescale_Select = 0b010
#define Timer_5_Prescale_8		Timer_5_Prescale_Select = 0b011
#define Timer_5_Prescale_16		Timer_5_Prescale_Select = 0b100
#define Timer_5_Prescale_32		Timer_5_Prescale_Select = 0b101
#define Timer_5_Prescale_64		Timer_5_Prescale_Select = 0b110
#define Timer_5_Prescale_256	Timer_5_Prescale_Select = 0b111
#define Timer_5_Count TMR5
#define Timer_5_Period PR5

/*<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>*/

#include "timer_config_Initialization.h"
#include "timer_config_PWM.h"
#include "timer_config_RoverMeasure.h"
#if defined(BaseStation)
#include "timer_config_CN.h"
#endif

void configure_timers() {
		printConfigurationStarted(Timers);
    printf("\r\n\tvoid configure_timers()");
    configure_initialization_timer();
	#if defined(Rover)
    configure_PWM_timer();
		configure_RoverMeasure_timer();
	#elif defined(BaseStation)
		configure_CN_timer();
	#endif
		printConfigurationCompleted(Timers);
}

#endif	/* TIMER_CONFIG_H */

